<html>
<head>
<title>OgreBone.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreBone.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreBone_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __Bone_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __Bone_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreNode_8h.html">OgreNode.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre 
<a name="l00037"></a>00037 {
<a name="l00051"></a><a class="code" href="classOgre_1_1Bone.html">00051</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>
<a name="l00052"></a>00052     {
<a name="l00053"></a>00053     <span class="keyword">public</span>:
<a name="l00055"></a>00055         <a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle, <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* creator);
<a name="l00057"></a>00057         <a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle, <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* creator);
<a name="l00058"></a>00058         ~<a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>();
<a name="l00059"></a>00059 
<a name="l00071"></a>00071         <a class="code" href="classOgre_1_1Bone.html" title="A bone in a skeleton.">Bone</a>* createChild(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> handle, 
<a name="l00072"></a>00072             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; translate = <a class="code" href="classOgre_1_1Vector3.html#a5da94afc089ec07612b4a2615bb6b86f">Vector3::ZERO</a>, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rotate = <a class="code" href="classOgre_1_1Quaternion.html#a441b8d52549e1dedec27420325a313ef">Quaternion::IDENTITY</a>);
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 
<a name="l00076"></a>00076         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getHandle(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00077"></a>00077 
<a name="l00081"></a>00081         <span class="keywordtype">void</span> setBindingPose(<span class="keywordtype">void</span>);
<a name="l00082"></a>00082 
<a name="l00089"></a>00089         <span class="keywordtype">void</span> reset(<span class="keywordtype">void</span>);
<a name="l00090"></a>00090 
<a name="l00103"></a>00103         <span class="keywordtype">void</span> setManuallyControlled(<span class="keywordtype">bool</span> manuallyControlled);
<a name="l00104"></a>00104 
<a name="l00106"></a>00106         <span class="keywordtype">bool</span> isManuallyControlled() <span class="keyword">const</span>;
<a name="l00107"></a>00107 
<a name="l00108"></a>00108         
<a name="l00113"></a>00113         <span class="keywordtype">void</span> _getOffsetTransform(<a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; m) <span class="keyword">const</span>;
<a name="l00114"></a>00114 
<a name="l00116"></a><a class="code" href="classOgre_1_1Bone.html#aafcb028d0902767f09f883c70717398b">00116</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; <a class="code" href="classOgre_1_1Bone.html#aafcb028d0902767f09f883c70717398b" title="Gets the inverted binding pose scale.">_getBindingPoseInverseScale</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mBindDerivedInverseScale; }
<a name="l00118"></a><a class="code" href="classOgre_1_1Bone.html#a79562d8818133b6f12b619f97bac4e18">00118</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; <a class="code" href="classOgre_1_1Bone.html#a79562d8818133b6f12b619f97bac4e18" title="Gets the inverted binding pose position.">_getBindingPoseInversePosition</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mBindDerivedInversePosition; }
<a name="l00120"></a><a class="code" href="classOgre_1_1Bone.html#a1a7dacec2fbb7b515457f084e0290f14">00120</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; <a class="code" href="classOgre_1_1Bone.html#a1a7dacec2fbb7b515457f084e0290f14" title="Gets the inverted binding pose orientation.">_getBindingPoseInverseOrientation</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mBindDerivedInverseOrientation; }
<a name="l00121"></a>00121 
<a name="l00123"></a>00123         <span class="keywordtype">void</span> needUpdate(<span class="keywordtype">bool</span> forceParentUpdate = <span class="keyword">false</span>);
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 
<a name="l00126"></a>00126     <span class="keyword">protected</span>:
<a name="l00128"></a><a class="code" href="classOgre_1_1Bone.html#a573267268aa2bf42f59e15767129fd78">00128</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code" href="classOgre_1_1Bone.html#a573267268aa2bf42f59e15767129fd78" title="The numeric handle of this bone.">mHandle</a>;
<a name="l00129"></a>00129 
<a name="l00131"></a><a class="code" href="classOgre_1_1Bone.html#aade53e58f80065a41e55f45a5dddcf88">00131</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Bone.html#aade53e58f80065a41e55f45a5dddcf88" title="Bones set as manuallyControlled are not reseted in Skeleton::reset()">mManuallyControlled</a>;
<a name="l00132"></a>00132 
<a name="l00134"></a>00134         <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* createChildImpl(<span class="keywordtype">void</span>);
<a name="l00136"></a>00136         <a class="code" href="classOgre_1_1Node.html" title="Class representing a general-purpose node an articulated scene graph.">Node</a>* createChildImpl(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00137"></a>00137 
<a name="l00139"></a><a class="code" href="classOgre_1_1Bone.html#a66d6efbd9ecc2e4d94560654d430e81e">00139</a>         <a class="code" href="classOgre_1_1Skeleton.html" title="A collection of Bone objects used to animate a skinned mesh.">Skeleton</a>* <a class="code" href="classOgre_1_1Bone.html#a66d6efbd9ecc2e4d94560654d430e81e" title="Pointer back to creator, for child creation (not smart ptr so child does not preserve parent)...">mCreator</a>;
<a name="l00140"></a>00140 
<a name="l00142"></a><a class="code" href="classOgre_1_1Bone.html#a48d07c71af40ddb696afa33633d58ac5">00142</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Bone.html#a48d07c71af40ddb696afa33633d58ac5" title="The inversed derived scale of the bone in the binding pose.">mBindDerivedInverseScale</a>;
<a name="l00144"></a><a class="code" href="classOgre_1_1Bone.html#acdc59d92113b91d1b9986530b6a04332">00144</a>         <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> <a class="code" href="classOgre_1_1Bone.html#acdc59d92113b91d1b9986530b6a04332" title="The inversed derived orientation of the bone in the binding pose.">mBindDerivedInverseOrientation</a>;
<a name="l00146"></a><a class="code" href="classOgre_1_1Bone.html#a5baafdf51e1548d524190b8882d96259">00146</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Bone.html#a5baafdf51e1548d524190b8882d96259" title="The inversed derived position of the bone in the binding pose.">mBindDerivedInversePosition</a>;
<a name="l00147"></a>00147     };
<a name="l00148"></a>00148 
<a name="l00152"></a>00152 }
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
